# Flink SQL Gateway Python Client

A client library for accessing [Flink Job Manager REST API](https://nightlies.apache.org/flink/flink-docs-master/docs/ops/rest_api/)
(mostly generated by [OpenAPI Generator](https://github.com/openapi-generators))

# Compartibility Overview

| API Versions | Compatible Flink Versions | Comment                                                      |     |
| ------------ | ------------------------- | ------------------------------------------------------------ | --- |
| API V1       | flink-1.16.2 -> flink-2.1 | Allow users to submit statements to the gateway and execute. |     |

## Usage

First, create a client:

```python

```

## Advanced customizations

# Developer

1. Quick start

```bash
# code gen
make gen
make release

# release production
make release_production
```

2. Manual release

```shell
# 1. test, exit if fail
cd $(rev-parse --show-toplevel)/flink-job-manager-api && pytest tests

# 2. check current version
cd $(rev-parse --show-toplevel)
cat flink-job-manager-api/pyproject.toml | grep version
version=$(cat flink-job-manager-api/pyproject.toml| grep version | cut -d '"' -f2)

# 3. tag & release
release_tag='VERSION_TO_BE_SET'
poetry -C flink-job-manager-api/flink-job-manager-api/ version $release_tag
cd $(rev-parse --show-toplevel)
git add -u
git commit -m
git tag -d $release_tag || true
git tag "release-$version"
git push origin "release-$version"
```
